/* PROLOG for Windows version 1.0
Intelligence Software Corp. Copyright 1992, 1994 */

#include "types.h"
#include "function.h"

int WinTermCmp( HLOCAL hT1, HLOCAL hT2)
{
  int Succes = 1;
  pWinTerm T1, T2;
  ALHND SubT1, SubT2;
  char *n1, *n2;

  if( hT1 == NULL || hT2 == NULL)
    return 0;
  T1 = (pWinTerm) LocalLock( hT1);
  T2 = (pWinTerm) LocalLock( hT2);
  n1 = (char *) LocalLock( T1 -> Name);
  n2 = (char *) LocalLock( T2 -> Name);
  if( T1 -> Type == Functor && T2 -> Type == Functor)
    if( strcmp( n1, n2) == 0 && T1 -> Reps == T2 -> Reps) {
	  int i, r = T1 -> Reps;
	  SubT1 = (ALHND) LocalLock( T1 -> Args);
	  SubT2 = (ALHND) LocalLock( T2 -> Args);
	  for( i = 0; i < r && Succes; i++)
		Succes = WinTermCmp( (*SubT1)[i], (*SubT2)[i]);
      LocalUnlock( T1 -> Args);
      LocalUnlock( T2 -> Args);
	}
    else Succes = 0;
  else
    if( T1 -> Type != Functor && T2 -> Type != Functor)
      Succes = ! strcmp( n1, n2);
    else Succes = 0;
  LocalUnlock( T1 -> Name);
  LocalUnlock( T2 -> Name);
  LocalUnlock( hT1);
  LocalUnlock( hT2);
  return Succes;
}

int WinCompare( HLOCAL hS, HLOCAL hD, HLOCAL *hTop)
{
  int  Succes = 1;
  pWinTerm St, Dt;
  ALHND SubS, SubD;
  char *sname, *dname;

  if( hS == NULL || hD == NULL )
	return 0;
  St = (pWinTerm) LocalLock( hS);
  Dt = (pWinTerm) LocalLock( hD);
  sname = (char *) LocalLock( St -> Name);
  dname = (char *) LocalLock( Dt -> Name);
  if( St -> Type == Atom && Dt -> Type == Atom)
	Succes = ! strcmp( sname, dname);
  else
	if( St -> Type == Functor && Dt -> Type == Functor)
	  if( strcmp( sname, dname) == 0 && St -> Reps == Dt -> Reps) {
		int i, r = St -> Reps;
		SubS = (ALHND) LocalLock( St -> Args);
		SubD = (ALHND) LocalLock( Dt -> Args);
		for( i = 0; i < r && Succes; i++)
		  Succes = WinCompare((*SubS)[i], (*SubD)[i], hTop);
		LocalUnlock( St -> Args);
		LocalUnlock( Dt -> Args);
	  }
	  else Succes = 0;
	else
	  if( St -> Type == Variable && Dt -> Type == Variable) {
		if( strcmp( sname, "_") == 0 || strcmp( dname, "_") == 0)
		  Succes = 1;
		else
		  if((Succes = WinAgree( hS, hD, hTop)) == 1)
			*hTop = WinConcretAdd( sname, hD, *hTop);
	  }
	  else
		if( St -> Type == Variable || Dt -> Type == Variable) {
		  if( strcmp( sname, "_") == 0 || strcmp( dname, "_") == 0)
		  /* invisible variable */
			Succes = 1;
		  else {
			if( St -> Type == Variable)
			  Succes = WinConcretLook( sname, hD, hTop);
			else
			  Succes = WinConcretLook( dname, hS, hTop);
		  }
		}
		else /* s -> type == Functor && d -> type == Atom ||
				s -> type == Atom && d -> type == Functor */
		  Succes = 0;
  LocalUnlock( St -> Name);
  LocalUnlock( Dt -> Name);
  LocalUnlock( hS);
  LocalUnlock( hD);
  return Succes;
}

HLOCAL WinConcretAdd( char *name, HLOCAL hObject, HLOCAL hTop)
{
  HLOCAL hC, hTmp, hRet;
  pWinConcret Con;
  char *cname;
  int find = 0;

  for( hC = hTop; hC != NULL && ! find; ) {
	Con = (pWinConcret) LocalLock( hC);
	cname = (char *) LocalLock( Con -> Name);
	if( strcmp( name, cname) == 0)
	  if( WinTermCmp( Con -> Object, hObject))
		find = 1;
	LocalUnlock( Con -> Name);
	hTmp = Con -> Next;
	LocalUnlock( hC);
	hC = hTmp;
  }
  if( find)
	hRet = hTop;
  else {
	hC = WinAlloc( sizeof( struct WinConcret));
	Con = (pWinConcret) LocalLock( hC);
	Con -> Name = WinAlloc( strlen( name) + 1);
	cname = (char *) LocalLock( Con -> Name);
	strcpy( cname, name);
	LocalUnlock( Con -> Name);
	Con -> Object = WinTermCopy( hObject);
	Con -> Number = CountPut;
	Con -> Next = hTop;
	LocalUnlock( hC);
	hRet = hC;
  }
  return hRet;
}

int WinConcretLook( char *name, HLOCAL hMean, HLOCAL *hTop)
{
  int good = 1, find = 0;
  HLOCAL hC, hTmp;
  pWinConcret Con;
  pWinTerm Object;
  char *cname, *oname;

  for( hC = *hTop; hC != NULL && good && ! find; ) {
	Con = (pWinConcret) LocalLock( hC);
	cname = (char *) LocalLock( Con -> Name);
	if( strcmp( cname, name) == 0) {
	  Object = (pWinTerm) LocalLock( Con -> Object);
	  oname = (char *) LocalLock( Object -> Name);
	  if( Object -> Type == Variable)
		good = WinConcretLook( oname, hMean, hTop);
	  else
		good = WinCompare( Con -> Object, hMean, hTop);
	  find = 1;
	  LocalUnlock( Object -> Name);
	  LocalUnlock( Con -> Object);
	}
	LocalUnlock( Con -> Name);
	hTmp = Con -> Next;
	LocalUnlock( hC);
	hC = hTmp;
  }
  if(! find)
	*hTop = WinConcretAdd( name, hMean, *hTop);
  return good;
}

int WinAgree( HLOCAL hS, HLOCAL hD, HLOCAL *hTop)
{
  pWinTerm St, Dt, Tmp;
  int conform = 1, Type;
  HLOCAL hC, hE, hTmp;
  pWinConcret Ccon, Econ;
  char *cname, *sname, *dname, *ename;

  St = (pWinTerm) LocalLock( hS);
  Dt = (pWinTerm) LocalLock( hD);
  sname = (char *) LocalLock( St -> Name);
  dname = (char *) LocalLock( Dt -> Name);
  for( hC = *hTop; hC != NULL && conform; ) {
	Ccon = (pWinConcret) LocalLock( hC);
	cname = (char *) LocalLock( Ccon -> Name);
	if( strcmp( sname, cname) == 0)
	  if(! WinTermCmp( hD, Ccon -> Object)) {
		Tmp = (pWinTerm) LocalLock( Ccon -> Object);
		Type = Tmp -> Type;
		LocalUnlock( Ccon -> Object);
	if( Type == Variable)
	  conform = WinAgree( Ccon -> Object, hD, hTop);
	else
	  for( hE = *hTop; hE != NULL && conform; ) {
		Econ = (pWinConcret) LocalLock( hE);
		ename = (char *) LocalLock( Econ -> Name);
		if( strcmp( dname, ename) == 0)
		  if(! WinTermCmp( hS, Econ -> Object)) {
			Tmp = (pWinTerm) LocalLock( Econ -> Object);
			Type = Tmp -> Type;
			LocalUnlock( Econ -> Object);
			if( Type == Variable)
			  conform = WinAgree( Econ -> Object, hS, hTop);
			else
			  conform = WinCompare( Ccon -> Object,
						Econ -> Object, hTop);
		  }
		  LocalUnlock( Econ -> Name);
		  hTmp = Econ -> Next;
		  LocalUnlock( hE);
		  hE = hTmp;
	  }
	  }
	LocalUnlock( Ccon -> Name);
	hTmp = Ccon -> Next;
	LocalUnlock( hC);
	hC = hTmp;
  }
  LocalUnlock( St -> Name);
  LocalUnlock( Dt -> Name);
  LocalUnlock( hS);
  LocalUnlock( hD);
  return conform;
}
