/* PROLOG for Windows version 1.0
Intelligence Software Corp. Copyright 1992, 1994 */

#include "types.h"
#include "function.h"

//HWND hResFile = NULL;
//HWND hResWindow = NULL;
int fError;
long int CountPut = 0;
int Trace = 0; /* trace indicator */
char Cut[] = "!";
char False[] = "fail";
char True[] = "true";

int WinLike( HLOCAL hSent, HLOCAL hTarg)
{
  int similar = 1;
  pWinTerm Sent, Targ;
  char *sname, *tname;

  Sent = (pWinTerm) LocalLock( hSent);
  Targ = (pWinTerm) LocalLock( hTarg);
  sname = (char *) LocalLock( Sent -> Name);
  tname = (char *) LocalLock( Targ -> Name);
  if( Sent -> Type == Variable || Targ -> Type == Variable )
        similar = 1;
  else
        if( Sent -> Type != Targ -> Type)
          similar = 0;
        else
          if( strcmp( sname, tname) == 0 && Sent -> Reps == Targ -> Reps)
                similar = 1;
          else
                similar = 0;
  LocalUnlock( Targ -> Name);
  LocalUnlock( Sent -> Name);
  LocalUnlock( hTarg);
  LocalUnlock( hSent);
  return similar;
}

int WinCompute( HLOCAL hTopSent, HLOCAL hTarget, HLOCAL *hTopCon, int *cut)
{
  int  Succes = 0, Cutlog = 0, cuts = 1, leave = 0;
  HLOCAL hCopySent = NULL, hCurSent = NULL, hTopVn = NULL,
                 hNewPurpose = NULL, hCopyCon = NULL, hFact = NULL, hTmp;
  pWinSent CurSent, CopySent;
  pWinFact Fact, Targ;
  pWinTerm Term;
  char *tname;

  while( hTarget != NULL && ! leave) {
        Targ = (pWinFact) LocalLock( hTarget);
        Term = (pWinTerm) LocalLock( Targ -> Term);
        tname = (char *) LocalLock( Term -> Name);
        if((cuts = strcmp( tname, Cut)) == 0 || strcmp( tname, True) == 0) {
          if(! cuts) *cut = 1;
        }
        else
          leave = 1;
        LocalUnlock( Term -> Name);
        LocalUnlock( Targ -> Term);
        if(! leave) {
          hTmp = Targ -> Next;
          LocalUnlock( hTarget);
          hTarget = hTmp;
        }
        else
          LocalUnlock( hTarget);
  }
  if( hTarget != NULL) {
        Targ = (pWinFact) LocalLock( hTarget);
        Term = (pWinTerm) LocalLock( Targ -> Term);
        tname = (char *) LocalLock( Term -> Name);
        if( strcmp( tname, False) == 0)
          leave = 1;
        else
          leave = 0;
        LocalUnlock( Term -> Name);
        LocalUnlock( Targ -> Term);
        LocalUnlock( hTarget);
  }
  if( leave) return 0;
  if( hTarget == NULL)
        Succes = WinResult( *hTopCon);
  else {
        Targ = (pWinFact) LocalLock( hTarget);
        CountPut += 1;
        for( hCurSent = hTopSent; hCurSent != NULL && ! Succes && ! Cutlog; ) {
          CurSent = (pWinSent) LocalLock( hCurSent);
          if( WinLike( CurSent -> Head, Targ -> Term))  {
                hCopySent = WinSentCopy( hCurSent);
                CopySent = (pWinSent) LocalLock( hCopySent);
                WinDiffrent( CopySent -> Head, &hTopVn);
                for( hFact = CopySent -> Body; hFact != NULL; ) {
                  Fact = (pWinFact) LocalLock( hFact);
                  WinDiffrent( Fact -> Term, &hTopVn);
                  hTmp = Fact -> Next;
                  LocalUnlock( hFact);
                  hFact = hTmp;
                }
                WinVarNameDelete( hTopVn);
                hTopVn = NULL;
                hCopyCon = WinConcretCopy( *hTopCon);
                if( WinCompare( Targ -> Term, CopySent -> Head, &hCopyCon)) {
                  hFact = hNewPurpose = WinConcat( CopySent -> Body,
                                                                                   WinFactCopy( Targ -> Next));
                  CopySent -> Body = NULL;
                  while( hFact != NULL) {
                        Fact = (pWinFact) LocalLock( hFact);
                        Fact -> Term = WinPlace( Fact -> Term, hCopyCon);
                        hTmp = Fact -> Next;
                        LocalUnlock( hFact);
                        hFact = hTmp;
                  }
                  //LocalUnlock( hCopySent);
                  //LocalUnlock( hCurSent);
                  //LocalUnlock( hTarget);
                  Succes = WinCompute( hTopSent, hNewPurpose, &hCopyCon, &Cutlog);
                  //LocalLock( hCopySent);
                  //LocalLock( hCurSent);
                  //LocalLock( hTarget);
                  if( CurSent -> Cuts) Cutlog = 0;
                  WinFactDelete( hNewPurpose);
                }
                else // No Comparision
                  ;
                WinConcretDelete( hCopyCon);
                LocalUnlock( hCopySent);
                WinSentDelete( hCopySent);
          }
          hTmp = CurSent -> Next;
          LocalUnlock( hCurSent);
          hCurSent = hTmp;
        }
        CountPut -= 1;
        LocalUnlock( hTarget);
        if( Cutlog == 1) *cut = 1;
  }
  return Succes;
}

int WinFileRead( HLOCAL *hTopSent, HLOCAL *hTopQuest, HLOCAL hProgram)
{
  int Succes = 1;
  pWinSent Sent;
  HLOCAL hTmp, hCurS, hCurQ;
  char *end, chois, *line, save;

  *hTopSent = NULL;
  *hTopQuest = NULL;
  line = (char *) LocalLock( hProgram);
  if((end = strchr( line,'.')) != NULL) {
    end++;
    save = *end;
    *end = '\0';
  }
  else
    Succes = 0;
  while( line != NULL && *line != '\0') {
    switch( chois = WinAnalys( line)) {
      case 'f':
      case 'r':
        if( *hTopSent == NULL) {
          hCurS = WinSentRead( line, chois);
          *hTopSent = hCurS;
        }
        else {
          Sent = (pWinSent) LocalLock( hCurS);
          hTmp = WinSentRead( line, chois);
          Sent -> Next = hTmp;
          LocalUnlock( hCurS);
          hCurS = hTmp;
        }
        break;
      case 'q':
        if( *hTopQuest == NULL) {
          hCurQ = WinSentRead( line, chois);
          *hTopQuest = hCurQ;
        }
        else {
          Sent = (pWinSent) LocalLock( hCurQ);
          hTmp = WinSentRead( line, chois);
          Sent -> Next = hTmp;
          LocalUnlock( hCurQ);
          hCurQ = hTmp;
        }
        break;
    }
    if( end != NULL) {
      *end = save;
      line = end;
      if((end = strchr( line,'.')) != NULL) {
        end++;
        save = *end;
        *end = '\0';
      }
    }
    else
      line = NULL;
  }
  if(Succes == 0)
        fError = (fError == 0) ? 2 : fError;
  LocalUnlock( hProgram);
//  LocalFree( hProgram);
  return Succes;
}

int PrologRun(
#ifdef __TOS_OS2__
void* hProgram
#else
unsigned int hProgram
#endif
)
{
  HLOCAL hTopCon, hTopSent, hTopQuest, hCurQuest;
  int retval = 0;

  fError = 0;
  hTopCon = NULL;
  if(! WinFileRead( &hTopSent, &hTopQuest, (HLOCAL) hProgram))
    retval = 0;
  else
  {
    pWinSent CurQuest;
    HLOCAL hTmp;

#ifdef __TOS_OS2__
  OpenResFile();
#else
/*
    if(! OpenResFile())
      MessageBox( "Cannot save Results", NULL,
                  MB_OK | MB_ICONHAND);
*/
#endif
    for( hCurQuest = hTopQuest; hCurQuest != NULL; ) {
      int Cut = 0;
      char *message;

      CurQuest = (pWinSent) LocalLock( hCurQuest);
      // srand((unsigned) strlen( file));
      retval = WinCompute( hTopSent, CurQuest -> Body, &hTopCon, &Cut);
      if (retval)
        WinPuts("Yes");
      else
        WinPuts("No");
      WinPuts("\n");
      hTmp = CurQuest -> Next;
      LocalUnlock( hCurQuest);
      hCurQuest = hTmp;
    }
    WinSentDelete( hTopSent);
    WinSentDelete( hTopQuest);
#ifdef __TOS_OS2__
  CloseResFile();
#else
//    CloseResFile(HWindow);
#endif
  }
  return retval;
}

