/* PROLOG for Windows version 1.0
Intelligence Software Corp. Copyright 1992, 1994 */

#include "types.h"
#include "function.h"

HLOCAL WinTermCopy( HLOCAL hSrc)
{
  char *cname, *sname;
  HLOCAL hCopy;
  ALHND SubT, SubC;
  pWinTerm Term, Copy;

  if( hSrc == NULL) return NULL;
  hCopy = WinAlloc( sizeof( struct WinTerm));
  Copy = (pWinTerm) LocalLock( hCopy);
  Term = (pWinTerm) LocalLock( hSrc);
  sname = (char *) LocalLock( Term -> Name);
  Copy -> Name = WinAlloc( strlen( sname) + 1);
  cname = (char *) LocalLock( Copy -> Name);
  strcpy( cname, sname);
  LocalLock( Term -> Name);
  LocalLock( Copy -> Name);
  Copy -> Type = Term -> Type;
  if( Term -> Type == Functor) {
	int i, r = Copy -> Reps = Term -> Reps;
	Copy -> Args = WinAlloc( r * sizeof(HLOCAL));
	SubT = (ALHND) LocalLock( Term -> Args);
	SubC = (ALHND) LocalLock( Copy -> Args);
	for( i = 0; i < r; i++)
	  (*SubC)[i] = WinTermCopy((*SubT)[i]);
	LocalUnlock( Term -> Args);
	LocalUnlock( Copy -> Args);
  }
  else
  {
	Copy -> Reps = 0;
	Copy -> Args = NULL;
  }
  LocalUnlock( hSrc);
  LocalUnlock( hCopy);
  return hCopy;
}

HLOCAL WinFactCopy( HLOCAL hFact)
{
  HLOCAL hTmp, hRet, hCopy;
  pWinFact Fact, Copy;

  if( hFact == NULL) return NULL;
  hRet = hCopy = WinAlloc( sizeof( struct WinFact));
  while( hFact != NULL) {
    Fact = (pWinFact) LocalLock( hFact);
    Copy = (pWinFact) LocalLock( hCopy);
    Copy -> Term = WinTermCopy( Fact -> Term);
    if( Fact -> Next != NULL) {
      hTmp = Copy -> Next = WinAlloc( sizeof( struct WinFact));
      LocalUnlock( hCopy);
      hCopy = hTmp;
      hTmp = Fact -> Next;
      LocalUnlock( hFact);
      hFact = hTmp;
    }
    else {
      Copy -> Next = NULL;
      LocalUnlock( hCopy);
      LocalUnlock( hFact);
      break;
    }
  }
  return hRet;
}

HLOCAL WinSentCopy( HLOCAL hSrc)
{
  HLOCAL hCopy;
  pWinSent Sent, Copy;

  if( hSrc == NULL) return NULL;
  Sent = (pWinSent) LocalLock( hSrc);
  hCopy = WinAlloc( sizeof( struct WinSent));
  Copy = (pWinSent) LocalLock( hCopy);
  Copy -> Cuts = Sent -> Cuts;
  Copy -> Head = WinTermCopy( Sent -> Head);
  Copy -> Body = WinFactCopy( Sent -> Body);
  Copy -> Next = NULL;
  LocalUnlock( hCopy);
  LocalUnlock( hSrc);
  return hCopy;
}

HLOCAL WinConcretCopy( HLOCAL hSrc)
{
  pWinConcret Copy, Src;
  HLOCAL hCopy, hTmp, hRet;
  char *cname, *sname;

  if(hSrc == NULL) return NULL;
  hRet = hCopy = WinAlloc( sizeof( struct WinConcret));
  while( hSrc != NULL) {
    Src = (pWinConcret) LocalLock( hSrc);
	Copy = (pWinConcret) LocalLock( hCopy);
    sname = (char *) LocalLock( Src -> Name);
    Copy-> Name = WinAlloc( strlen( sname) + 1);
    cname = (char *) LocalLock( Copy -> Name);
    strcpy( cname, sname);
    LocalUnlock( Copy -> Name);
    LocalUnlock( Src -> Name);
    Copy -> Object = WinTermCopy( Src -> Object);
    Copy -> Number = Src -> Number;
    if( Src -> Next != NULL) {
      hTmp = Copy -> Next = WinAlloc( sizeof( struct WinConcret));
      LocalUnlock( hCopy);
      hCopy = hTmp;
      hTmp = Src -> Next;
      LocalUnlock( hSrc);
      hSrc = hTmp;
    }
    else {
      Copy -> Next = NULL;
      LocalUnlock( hCopy);
      LocalUnlock( hSrc);
      break;
    }
  }
  return hRet;
}

void WinSentDelete( HLOCAL hDest)
{
  pWinSent Dest;

  if( hDest == NULL) return;
  Dest = (pWinSent) LocalLock( hDest);
  WinTermDelete( Dest -> Head);
  WinFactDelete( Dest -> Body);
//  WinSentDelete( Dest -> Next);
  LocalLock( hDest);
  WinDelete( hDest);
}

void WinFactDelete( HLOCAL hDest)
{
  HLOCAL hTmp;
  pWinFact Dest;

  while( hDest != NULL) {
    Dest = (pWinFact) LocalLock( hDest);
    WinTermDelete( Dest -> Term);
    hTmp = Dest -> Next;
    LocalUnlock( hDest);
    WinDelete( hDest);
    hDest = hTmp;
  }
}

void WinConcretDelete( HLOCAL hDest)
{
  HLOCAL hTmp;
  pWinConcret Dest;

  while( hDest != NULL) {
    Dest = (pWinConcret) LocalLock( hDest);
    WinDelete( Dest -> Name);
    WinTermDelete( Dest -> Object);
    hTmp = Dest -> Next;
    LocalUnlock( hDest);
    WinDelete( hDest);
    hDest = hTmp;
  }
}

void WinVarNameDelete( HLOCAL  hDest)
{
  pWinVarName Dest;
  HLOCAL hTmp;

  while( hDest != NULL) {
    Dest = (pWinVarName) LocalLock( hDest);
    WinDelete( Dest -> Name);
    WinDelete( Dest -> DiffName);
    hTmp = Dest -> Next;
    LocalUnlock( hDest);
    WinDelete( hDest);
    hDest = hTmp;
  }
}

void WinTermDelete( HLOCAL hFree)
{
  pWinTerm Term;
  ALHND SubT;

  if( hFree == NULL) return;
  Term = (pWinTerm) LocalLock( hFree);
  WinDelete( Term -> Name);
  if( Term -> Type == Functor) {
    int i, r = Term -> Reps;
    SubT = (ALHND) LocalLock( Term -> Args);
    for( i = 0; i < r; i++)
      WinTermDelete((*SubT)[i]);
    LocalUnlock( Term -> Args);
    WinDelete( Term -> Args);
  }
  LocalUnlock( hFree);
  WinDelete( hFree);
}
