/* PROLOG for Windows version 1.0
Intelligence Software Corp. Copyright 1992, 1994 */

#include "types.h"
#include "function.h"

void WinTermPrint( HLOCAL hTerm)
{
  pWinTerm Term;
  ALHND SubT;
  char *tname;

  if( hTerm == NULL) return;
  Term = (pWinTerm) LocalLock( hTerm);
  tname = (char *) LocalLock( Term -> Name);
  WinPuts( tname);
  LocalUnlock( Term -> Name);
  if( Term -> Type == Functor) {
    int i = 0, r = Term -> Reps;
    SubT = (ALHND) LocalLock( Term -> Args);
    WinPuts("(");
    for( i = 0; i < r; i++) {
      WinTermPrint((*SubT)[i]);
      if( i < r - 1) WinPuts(",");
	}
	LocalUnlock( Term -> Args);
	WinPuts(")");
  }
  LocalUnlock( hTerm);
}

void WinVarPrint( char *name, HLOCAL hTopCon)
{
  HLOCAL hCon = hTopCon, hTmp;
  pWinTerm Object;
  pWinConcret Con;
  char *cname, *oname;
  int find = 0;

  while( hCon != NULL && ! find) {
    Con = (pWinConcret) LocalLock( hCon);
    cname = (char *) LocalLock( Con -> Name);
    if( strcmp( cname, name) == 0) {
	  Object = (pWinTerm) LocalLock( Con -> Object);
      oname = (char *) LocalLock( Object -> Name);
      if( Object -> Type == Variable)
        WinVarPrint( oname, hTopCon);
      else
        WinTermPrint(( Con -> Object = WinPlace( Con -> Object, hTopCon)));
      find = 1;
	  LocalUnlock( Object -> Name);
	  LocalUnlock( Con -> Object);
	}
	LocalUnlock( Con -> Name);
	hTmp = Con -> Next;
	LocalUnlock( hCon);
	hCon = hTmp;
  }
  if(! find) WinPuts( name);
}
