/* PROLOG for Windows version 1.0
Intelligence Software Corp. Copyright 1992, 1994 */

#include "types.h"
#include "function.h"

extern char Cut[];
static char listname[] = ".";
static char listend[] = "[]";

char WinAnalys( char *s)
{
 char c = 'f';
 if( strstr( s,":-") != NULL) c = 'r';
 if( strstr( s,"?-") != NULL) c = 'q';
 return c;
}

ttype WinVariable( char *s)
{
  if( *s == '_' || isupper( *s) ) return Variable;
  else return Atom;
}

char *WinGetTerm( char *src)
{
  char *brk = strchr( src, '(');
  char *spr = strchr( src, ',');
  char *dvn = strchr( src, '|');
  char *end = strchr( src, ')');
  char *lst1 = strchr( src, '[');
  char *lst2 = strchr( src, ']');
  char *ret = NULL;

  if( end == NULL) end = strchr( src, '.');
  if( lst1 != NULL && lst2 != NULL)
  {
    char *l;
    int cnt = 1;

    for( l = lst1 + 1; *l != '\0'; l++)
    {
      if( *l == '[') cnt++;
      if( *l == ']') cnt--;
      if( cnt == 0)
      {
        lst2 = l;
        break;

      }
    }
    while( spr != NULL && spr > lst1 && spr < lst2)
      spr = strchr( spr + 1, ',');
    ret = lst2 + 1;
    if( brk != NULL && brk > lst1 && brk < lst2)
      brk = strchr( ret, '(');
    if( dvn != NULL && dvn > lst1 && dvn < lst2)
      dvn = strchr( ret, '|');
    if( end != NULL && end > lst1 && end < lst2)
      end = strchr( ret, ')');
  }
  if( end == NULL) end = strrchr( src, ']');
  if( spr == NULL) spr = end;
  if( dvn == NULL) dvn = end;
  if( brk == NULL || spr < brk || dvn < brk)
    if( brk == NULL)
      ret = (spr < dvn) ? spr : dvn;
    else
      ret = (spr < brk) ? spr : dvn;
  else
  {
    int cnt_brk = 1;
    char *p;

    for( p = brk + 1; p != NULL; p++)
    {
      if( *p == '(') cnt_brk++;
      if( *p == ')') cnt_brk--;
      if( cnt_brk == 0)
      {
        ret = p + 1;
        break;
      }
    }
    if( p == NULL)
      ret = NULL;
  }
  return ret;
}

int ArgsCount( char *first)
{
  int count = 0;
  char *bgn = first, *s = NULL;

  while( bgn != NULL)
  {
        if((s = WinGetTerm( bgn)) != NULL)
        {
          if( *s == ',' || *s == ')') count++;
          if( *s == ')') break;
        }
        bgn = s + 1;
  }
  return count;
}

HLOCAL WinTermRead( char *src)
{
  char *end, *name;
  HLOCAL hTerm;
  ALHND SubT;
  pWinTerm Term;

  if( src == NULL) return NULL;
  hTerm =  WinAlloc( sizeof( struct WinTerm));
  Term = (pWinTerm) LocalLock( hTerm);
  if( *src == '[' && strchr( src, ']') != NULL)
        if( strcmp( src, listend) == 0)
        {
          Term -> Name = WinAlloc( strlen( listend) + 1);
          name = (char *) LocalLock( Term -> Name);
          strcpy( name, listend);
          LocalUnlock( Term -> Name);
          Term -> Type = Atom;
          Term -> Reps = 0;
          Term -> Args = NULL;
        }
        else
        {
          LocalUnlock( hTerm);
          WinDelete( hTerm);
          return WinListRead( src);
        }
  else
        if(( end = strchr( src,'(')) == NULL)   {
          Term -> Type = WinVariable( src);
          Term -> Name = WinAlloc( strlen( src) + 1);
          name = (char *) LocalLock( Term -> Name);
          strcpy( name, src);
          LocalUnlock( Term -> Name);
          Term -> Reps = 0;
          Term -> Args = NULL;
        }
        else {
          int i, r;
          Term -> Type = Functor;
          *end = '\0'; end += 1;
          Term -> Name = WinAlloc( strlen( src) + 1);
          name = (char *) LocalLock( Term -> Name);
          strcpy( name, src);
          LocalUnlock( Term -> Name);
          src = end;
          r = Term -> Reps = ArgsCount( src);
          Term -> Args = WinAlloc( r * sizeof(HLOCAL));
          SubT = (ALHND) LocalLock( Term -> Args);
          for( i = 0; i < r; i++) {
                if((end = WinGetTerm( src)) != NULL) {
                  *end = '\0';
                  (*SubT)[i] = WinTermRead( src);
                  src = end + 1;
                }
                else { /*       Error !!!!!!! */ }
          }
          LocalUnlock( Term -> Args);
        }
  LocalUnlock( hTerm);
  return hTerm;
}

HLOCAL WinListRead( char *src)
{
  HLOCAL hRet, hCur, hTmp;
  pWinTerm Term, Cur;
  ALHND SubT;
  char *end, *tname, save;

  src = strchr( src,'[') + 1;
  hRet = hCur = WinAlloc( sizeof( struct WinTerm));
  while(1) {
        Term = (pWinTerm) LocalLock( hCur);
        if(( end = WinGetTerm( src)) != NULL) {
          Term -> Name = WinAlloc( strlen( listname) + 1);
          tname = (char *) LocalLock( Term -> Name);
          strcpy( tname, listname);
          LocalUnlock( Term -> Name);
          Term -> Type = Functor;
          Term -> Reps = 2;
          Term -> Args = WinAlloc( 2 * sizeof( HLOCAL));
          save = *end; *end = '\0';
          SubT = (ALHND) LocalLock( Term -> Args);
          (*SubT)[0] = WinTermRead( src);
          (*SubT)[1] = NULL;
          LocalUnlock( Term -> Args);
          src = end + 1;
        }
        else {
          Term -> Name = WinAlloc( strlen( listend) + 1);
          tname = (char *) LocalLock( Term -> Name);
          strcpy( tname, listend);
          LocalUnlock( Term -> Name);
          Term -> Type = Atom;
          Term -> Reps = 0;
          Term -> Args = NULL;
          LocalUnlock( hCur);
#ifndef __TOS_OS2__
          ErrorMessage(" String %s not included Term ", src);
#endif
          break;
        }
        if( save == '|') {
          end = WinGetTerm( src);
          SubT = (ALHND) LocalLock( Term -> Args);
          *end = '\0';
          (*SubT)[1] = WinTermRead( src);
          LocalUnlock( Term -> Args);
          LocalUnlock( hCur);
          break;
        }
        else
          if( save == ']') {
                SubT = (ALHND) LocalLock( Term -> Args);
                hTmp = (*SubT)[1] = WinAlloc( sizeof( struct WinTerm));
                LocalUnlock( Term -> Args);
                LocalUnlock( hCur);
                Term = (pWinTerm) LocalLock( hTmp);
                Term -> Name = WinAlloc( strlen( listend) + 1);
                tname = (char *) LocalLock( Term -> Name);
                strcpy( tname, listend);
                LocalUnlock( Term -> Name);
                Term -> Type = Atom;
                Term -> Reps = 0;
                Term -> Args = NULL;
                LocalUnlock( hTmp);
                break;
          }
          else {
                SubT = (ALHND) LocalLock( Term -> Args);
                hTmp = (*SubT)[1] = WinAlloc( sizeof( struct WinTerm));
                LocalUnlock( Term -> Args);
                LocalUnlock( hCur);
                hCur = hTmp;
          }
  }
  return hRet;
}

HLOCAL WinSentRead( char *src, char u)
{
  char *p = src, *nxt, save, *name;
  HLOCAL hSent = WinAlloc( sizeof( struct WinSent)), hTmp, hCurF;
  pWinSent Sent = (pWinSent) LocalLock( hSent);
  pWinFact Fact;
  pWinTerm Term;

  if( src == NULL) {
        LocalUnlock( hSent);
        WinDelete( hSent);
        return NULL;
  }

  Sent -> Cuts = 0;
  if( u == 'q') Sent -> Head = NULL;
  if( u == 'f' || u == 'r') {
        for( ; *p != ':' && *p != '.'; p++) ;
        *p = '\0';
        Sent -> Head = WinTermRead( src);
  }
  if( u == 'f') Sent -> Body = NULL;
  if( u == 'r' || u == 'q') {
        src = (p += 2);         // :- or ?-
        nxt = WinGetTerm( src);
        if( nxt == NULL)
          Sent -> Body = NULL;
        else {
          Sent -> Body = hCurF = WinAlloc(sizeof(struct WinFact));
          while( nxt != NULL) {
                Fact = (pWinFact) LocalLock( hCurF);
                save = *nxt;
                *nxt = '\0';
                Fact -> Term = WinTermRead( src);
                Term = (pWinTerm) LocalLock( Fact -> Term);
                name = (char *) LocalLock( Term -> Name);
                if( strcmp( name, Cut) == 0)
                  Sent -> Cuts = 1;
                LocalUnlock( Term -> Name);
                LocalUnlock( Fact -> Term);
                if( save == '.') {
                  Fact -> Next = NULL;
                  LocalUnlock( hCurF);
                  break;
                }
                //      *nxt = save;
                src = ++nxt;
                hTmp = Fact -> Next = WinAlloc( sizeof( struct WinFact));
                LocalUnlock( hCurF);
                hCurF = hTmp;
                nxt = WinGetTerm( src);
          }
        }
  }
  Sent -> Next = NULL;
  LocalUnlock( hSent);
  return hSent;
}
