/* PROLOG for Windows version 1.0
Intelligence Software Corp. Copyright 1992, 1994 */

#include "types.h"
#include "function.h"

#define TMPLONG 20
#define RADIX 10
#define BUFSIZE 1024

#ifdef __TOS_OS2__
FILE *resFile;
#else
HFILE hResFile;
struct stat FileStatus;
OFSTRUCT OfStruct;
HANDLE hBuffer;
PSTR pBuffer;
#endif

int IOStatus;
short xChar, yChar;

char Buffer[BUFSIZE];
int OutCnt = BUFSIZE;
char *ptr = Buffer;

int OpenResFile(void)
{
  OutCnt = BUFSIZE;
  ptr = Buffer;

#ifdef __TOS_OS2__
  if((resFile = fopen("RESULT.TMP","w")) == NULL)
    return 0;
#else
  if((hResFile = OpenFile("RESULT.TMP",(LPOFSTRUCT) &OfStruct,
                          OF_CREATE)) == HFILE_ERROR) {
    hResFile = NULL;
    return 0;
  }
#endif
  else
    return 1;
}

int WinPuts( char *str)
{
#ifdef __TOS_OS2__
  if ( resFile != NULL ) 
    if ( fputs( str, resFile ) != EOF ) return 1;
  return 0;
#else
  int l = strlen( str), IOStatus, i;

  for( i = 0; i < l; i++) {
        OutCnt--;
        if( OutCnt < 0) {
          OutCnt = BUFSIZE;
          IOStatus = _lwrite( hResFile, Buffer, BUFSIZE);
          ptr = Buffer;
        }
        else
          *ptr++ = str[i];
  }
  return (IOStatus != BUFSIZE) ? -1 : l;
#endif
}

void CloseResFile(
#ifndef __TOS_OS2__
 HWND hWnd
#endif
)
{
#ifdef __TOS_OS2__
  if ( resFile != NULL )
    fclose( resFile );
#else
  int Size = BUFSIZE - OutCnt;

  IOStatus = _lwrite( hResFile, Buffer, Size);
  if( IOStatus != Size)
    MessageBox( hWnd, "Cannot save Results", NULL,
                MB_OK | MB_ICONHAND);
  _lclose( hResFile);
#endif
}

int WinResult( HLOCAL hTopCon)
{
  HLOCAL hCon = hTopCon, hTmp;
  pWinConcret Con;
  char *cname;

  while( hCon != NULL)
  {
        Con = (pWinConcret) LocalLock( hCon);
        cname = (char *) LocalLock( Con -> Name);
        if( strstr( cname, "__") != cname) {
          WinPuts( cname);
          WinPuts(" = ");
          WinVarPrint( cname, hTopCon);
          WinPuts("\n");
        }
        hTmp = Con -> Next;
        LocalUnlock( hCon);
        hCon = hTmp;
  }
  //    return (Trace == 1) ? 0 : 1;
  return 1;
}

/*
void ShowResult( HWND hWnd, unsigned message,
                                 WORD wParam, LONG lParam)
{
  HDC hDC;
  PAINTSTRUCT ps;
  POINT ptSize, ptOrigin;
  BITMAP bm;
  short yPos;
  char *s, *bgn;

  if( hBuffer != 0) {
  hDC = BeginPaint( hWnd, (PAINTSTRUCT FAR *) &ps);
  yPos = 0;
  pBuffer = LocalLock( hBuffer);
  OemToAnsi( pBuffer, pBuffer);
  bgn = pBuffer;
  while(( s = strchr( bgn, '\n')) != NULL) {
        *s = '\0';
        yPos += yChar;
        TextOut( hDC, xChar, yPos, bgn, strlen( bgn));
        bgn = s + 1;
  }
  LocalUnlock( hBuffer);
  EndPaint( hWnd, (PAINTSTRUCT FAR *) &ps);
  }
}
*/

HLOCAL WinTmpName(void)
{
  int l = 0;
  HLOCAL hMem = WinAlloc(TMPLONG);
  char *string = (char *) LocalLock( hMem);
  *string = '_';
  *(string + 1) = '_';
  itoa( rand(), string + 2, RADIX);
  l = strlen( string);
  *(string + l) = '\/';
  ultoa( CountPut, string + l + 1, RADIX);
  LocalUnlock(hMem);
  return hMem;
}

void WinDiffrent( HLOCAL hTerms, HLOCAL *hTop)
{
  int find = 0;
  pWinVarName Vn;
  HLOCAL hVn, hTmp;
  ALHND SubT;
  pWinTerm Term;
  char *name, *cname, *vname;

  if( hTerms == NULL) return;
  Term = (pWinTerm) LocalLock( hTerms);
  if( Term -> Type == Functor) {
        int i, r = Term -> Reps;
        SubT = (ALHND) LocalLock( Term -> Args);
        for( i = 0; i < r; i++)
          WinDiffrent((*SubT)[i], hTop);
        LocalUnlock( Term -> Args);
  }
  else
        if( Term -> Type == Variable) {
          name = (char *) LocalLock( Term -> Name);
          if( strcmp( name, "_") != 0) {        // visible variable
                for( hVn = *hTop; hVn != NULL && ! find; ) {
                  Vn = (pWinVarName) LocalLock( hVn);
                  cname = (char *) LocalLock( Vn -> Name);
                  if( strcmp( name, cname) == 0) {
                        find = 1;
                        LocalUnlock( Vn -> Name);
                        LocalUnlock( hVn);
                  }
                  else {
                        hTmp = Vn -> Next;
                        LocalUnlock( Vn -> Name);
                        LocalUnlock( hVn);
                        hVn = hTmp;
                  }
                }
                if(! find)
                {
                  hVn = WinAlloc( sizeof( struct WinVarName));
                  Vn = (pWinVarName) LocalLock( hVn);
                  Vn -> Name = WinAlloc( strlen( name) + 1);
                  vname = (char *) LocalLock( Vn -> Name);
                  strcpy( vname, name);
                  LocalUnlock( Vn -> Name);
                  LocalUnlock( Term -> Name);
                  WinDelete( Term -> Name);
                  Term -> Name = WinTmpName();
                  name = (char *) LocalLock( Term -> Name);
                  Vn -> DiffName = WinAlloc( strlen( name) + 1);
                  vname = (char *) LocalLock( Vn -> DiffName);
                  strcpy( vname, name);
                  LocalUnlock( Vn -> DiffName);
                  LocalUnlock( Term -> Name);
                  Vn -> Next = *hTop;
                  LocalUnlock( hVn);
                  *hTop = hVn;
                }
                else {
                  LocalUnlock( Term -> Name);
                  WinDelete( Term -> Name);
                  Vn = (pWinVarName) LocalLock( hVn);
                  cname = (char *) LocalLock( Vn -> DiffName);
                  Term -> Name = WinAlloc( strlen( cname) + 1);
                  name = (char *) LocalLock( Term -> Name);
                  strcpy( name, cname);
                  LocalUnlock( Term -> Name);
                  LocalUnlock( Vn -> DiffName);
                  LocalUnlock( hVn);
                }
          }
        }
        LocalUnlock( hTerms);
}       //end WinDiffrent

HLOCAL WinPlace( HLOCAL  hPurp, HLOCAL  hTop)
{
  pWinTerm Pur;
  HLOCAL hRet = hPurp, hCon, hTmp;
  ALHND SubT;
  char *name, *cname;
  pWinConcret Con;

  if( hPurp == NULL) return NULL;
  Pur = (pWinTerm) LocalLock( hPurp);
  if( Pur -> Type == Functor) {
        int i, r = Pur -> Reps;
        SubT = (ALHND) LocalLock( Pur -> Args);
        for( i = 0; i < r; i++)
          (*SubT)[i] = WinPlace( (*SubT)[i], hTop);
        LocalUnlock( Pur -> Args);
  }
  else
        if( Pur -> Type == Variable) {
          name = (char *) LocalLock( Pur -> Name);
          if( strcmp( name, "_") != 0) { // visible variable
                for( hCon = hTop; hCon != NULL;) {
                  Con = (pWinConcret) LocalLock( hCon);
                  cname = (char *) LocalLock( Con -> Name);
                  if( strcmp( name, cname) == 0) {
                        LocalUnlock( Pur -> Name);
                        LocalUnlock( hPurp);
                        WinDelete( hPurp);
                        hRet = WinTermCopy( Con -> Object);
                        hPurp = hRet = WinPlace( hRet, hTop);
                        Pur = (pWinTerm) LocalLock( hPurp);
                        name = (char *) LocalLock( Pur -> Name);
                        LocalUnlock( Con -> Name);
                        LocalUnlock( hCon);
                        break;
                  }
                  LocalUnlock( Con -> Name);
                  hTmp = Con -> Next;
                  LocalUnlock( hCon);
                  hCon = hTmp;
                }
          }
          LocalUnlock( Pur -> Name);
        }
        LocalUnlock( hPurp);
  return hRet;
}

HLOCAL WinConcat( HLOCAL hBody, HLOCAL hHead)
{
  pWinFact Cur;
  HLOCAL hTmp1, hTmp2;

  if( hBody != NULL) {
        hTmp1 = hBody;
        while(1) {
          Cur = (pWinFact) LocalLock( hTmp1);
          if( Cur -> Next == NULL) {
                Cur -> Next = hHead;
                LocalUnlock( hTmp1);
                return hBody;
          }
          else {
                hTmp2 = Cur -> Next;
                LocalUnlock( hTmp1);
                hTmp1 = hTmp2;
          }
        }
  }
  else return hHead;
}

void ErrorMessage( char *format, char *src)
{
  char EMessage[100];

  sprintf( EMessage, format, src);
#ifndef __TOS_OS2__
  MessageBox( NULL, EMessage, NULL, MB_OKCANCEL | MB_ICONQUESTION);
#endif
}

HLOCAL WinAlloc(int size)
{
#ifdef __TOS_OS2__
  return malloc( size );
#else
  HLOCAL hMem;

  if(( hMem = LocalAlloc( LHND, size)) == NULL)
        fError = 1;
//        MessageBox( NULL,"Not enough Memory !", NULL, MB_OK | MB_ICONQUESTION);
  return hMem;
#endif
}

void WinDelete( HLOCAL hFree)
{
#ifdef __TOS_OS2__
	free( hFree );
#else
        LocalFree( hFree);
#endif
}
